/*
 ClockEveryWhere Hack

Put into the public domain by Renaud malaval <renaud.malaval2@fnac.net>
 This file is the source code for the hack's preferences panel.

	File
	----
	code07d0.c

   History
   -------
   15/06/00 Created
*/


#include <PalmTypes.h>
//#include <event.h>
#include <form.h>
#include <SoundMgr.h>
#include <StringMgr.h>

#include <SysEvtMgr.h>
#include <HandEra/Silk.h>

#include <Table.h>
#include <HandEra/Vga.h>

// include system use only for test
#include <UIColor.h>
#include <TimeMgr.h>

#include "ClockEveryWhere.h"
#include "ResourceDefines.h"
#include "utils.h"


// The minimum OS version we support
#define kOurMinVersion	sysMakeROMVersion(3,5,0,sysROMStageRelease,0) 

// This is the code that will be called whenever the user taps myhack's "+"
// button in the HackMaster list. HackMaster is not smart about the content of
// this file; it will simply jump to the first executable statement in this
// file. If you need helper functions, prototype them above, and define them
// AFTER the trap patch.

//static void Clean_ClockZone(Boolean atRight)
static void Clean_CheckedBlink(FormPtr theFormP);
static void Clean_CheckedBack(FormPtr	theFormP);
static void GetCheckBoxValue(FormPtr theFormP, CEWpref_t *aPrefsPtr);
static void ForceClockRedraw(FormPtr theFormP);

static Boolean PrefsHandler(EventPtr eventP)
{
	FormPtr		theFormP;
	CEWpref_t	thePrefs;
	int			handled = 0;
	EventType	theInitEvent;

	theFormP = FrmGetActiveForm();

	switch (eventP->eType)
	{
	case frmOpenEvent:
        // Here, if the get app preferences operation fails, we initialize
        // the prefs and save them. This is the appropriate place to do
        // this, NOT in the OS trap patch routine.
//		SndPlaySystemSound (sndWarning);
		Utils_GetHackPref( &thePrefs);

		if (Utils_RomVersionCompatible (kOurMinVersion))
		{
			thePrefs.AnalogClockControlvalue = false;
			FrmHideObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_Analog) );	/* hide Analog clock option */
		}

		// set the check box ...
		CtlSetValue (GetObjectPtr ( theFormP, kCheckBoxIdControl_DisplayIfNameNumber),	thePrefs.DisplayIfNameIsNumberControlvalue );
		CtlSetValue (GetObjectPtr ( theFormP, kCheckBoxIdControl_DisplayAlert),			thePrefs.DisplayAlertClockControlvalue );
		CtlSetValue (GetObjectPtr ( theFormP, kCheckBoxIdControl_Blink),					thePrefs.BlinkingSecondControlvalue );
		CtlSetValue (GetObjectPtr ( theFormP, kCheckBoxIdControl_Analog),					thePrefs.AnalogClockControlvalue );
		CtlSetValue (GetObjectPtr ( theFormP, kCheckBoxIdControl_BackWhite),				thePrefs.WhiteBackgroundControlvalue );
		CtlSetValue (GetObjectPtr ( theFormP, kCheckBoxIdControl_DisplayAlertRight),	thePrefs.DisplayAlertClockRightControlvalue );
		CtlSetValue (GetObjectPtr ( theFormP, kCheckBoxIdControl_Add0Before1To9),		thePrefs.Add0Before1To9 );
		CtlSetValue (GetObjectPtr ( theFormP, kCheckBoxIdControl_BoldFont),				thePrefs.FontInBold );

		// select last format
		theInitEvent.eType = popSelectEvent;
		theInitEvent.data.popSelect.listP = GetObjectPtr( theFormP, kListId_Format);
		theInitEvent.data.popSelect.listID = kListId_Format;
		theInitEvent.data.popSelect.controlP = GetObjectPtr( theFormP, kPopUpTriggerId_Format);
		theInitEvent.data.popSelect.controlID = kPopUpTriggerId_Format;
		theInitEvent.data.popSelect.selection = thePrefs.DisplayAnalogOn12Hour;
		theInitEvent.data.popSelect.priorSelection = -1;
		EvtAddEventToQueue( &theInitEvent);
		LstSetSelection (theInitEvent.data.popSelect.listP, thePrefs.DisplayAnalogOn12Hour);

		if (thePrefs.AnalogClockControlvalue)
		{
			Clean_CheckedBlink( theFormP);
		}
		else
		{
			Clean_CheckedBack( theFormP);
		}

		FrmDrawForm(theFormP);
//		SndPlaySystemSound (sndWarning);
		handled = true;
		break;

	case popSelectEvent:
		{
			CtlSetLabel ( GetObjectPtr ( theFormP, kPopUpTriggerId_Format),
				LstGetSelectionText(eventP->data.popSelect.listP, LstGetSelection(eventP->data.popSelect.listP )) );
			ForceClockRedraw( theFormP);
			handled = true;
		}
		break;

	case ctlSelectEvent:
		switch (eventP->data.ctlEnter.controlID)
		{
		case kCheckBoxIdControl_Analog:
			if (CtlGetValue (GetObjectPtr (theFormP, kCheckBoxIdControl_Analog)))
			{
				Clean_CheckedBlink( theFormP);
			}
			else
			{
				Clean_CheckedBack( theFormP);
			}

		// INTENTIONAL FALL-THROUGH HERE
		case kCheckBoxIdControl_BackWhite:

		// INTENTIONAL FALL-THROUGH HERE
		case kCheckBoxIdControl_Blink:

		// INTENTIONAL FALL-THROUGH HERE
		case kCheckBoxIdControl_DisplayAlert:

		// INTENTIONAL FALL-THROUGH HERE
		case kCheckBoxIdControl_DisplayAlertRight:

		// INTENTIONAL FALL-THROUGH HERE
		case kCheckBoxIdControl_Add0Before1To9:
		
		// INTENTIONAL FALL-THROUGH HERE
		case kCheckBoxIdControl_BoldFont:
			ForceClockRedraw( theFormP);
			handled = true;
			break;

		case kButtonIdPrefOK:
			GetCheckBoxValue(theFormP, &thePrefs);
			PrefSetAppPreferences (kCreatorCode, kPrefIdNum, kVersionNum, &thePrefs, sizeof(thePrefs), true);

		// INTENTIONAL FALL-THROUGH HERE
		case kButtonIdPrefCancel:
			FrmGotoForm(9000);  // return to HackMaster control panel
			handled = true;
			break;
		}
		break;

	default:
		break;
	}

	return handled;
}	/* PrefsHandler */

/*
// This function is PalmOS v3.5 dependant.
static void Clean_ClockZone(Boolean atRight)
{
	RectangleType		theClockRec;
	IndexedColorType	theBackColor = WinSetBackColor (1);
	IndexedColorType	theForeColor = WinSetForeColor (theBackColor);

	WinSetBackColor (theForeColor );
	if (atRight)
		RctSetRectangle (&theClockRec, (kScreenWidth - (kDoubleClockWidth + 3)), kInAlertClockPositionY, kDoubleClockWidth, kClockHeight);
	else
		RctSetRectangle (&theClockRec, kInAlertClockPositionX, kInAlertClockPositionY, kDoubleClockWidth, kClockHeight);

	WinEraseRectangle (&theClockRec, 0);
	WinSetBackColor (theBackColor);
	WinSetForeColor (theForeColor);
}
*/

static void Clean_CheckedBlink(FormPtr theFormP)
{
	FrmHideObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_Blink) );	/* hide Blink */
	FrmHideObject (theFormP, FrmGetObjectIndex ( theFormP, kPopUpTriggerId_Format) );	/* hide Format */
	FrmHideObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_Add0Before1To9) ); /* hide 0 before 1 to 9 */
	FrmHideObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_BoldFont) );	/* draw in bold */	
	FrmShowObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_BackWhite) );	/* show backWhite */
}

static void Clean_CheckedBack(FormPtr	theFormP)
{
	FrmShowObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_Blink) );	/* show Blink */
	FrmShowObject (theFormP, FrmGetObjectIndex ( theFormP, kPopUpTriggerId_Format) );	/* show Format */
	FrmShowObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_Add0Before1To9) ); /* show 0 before 1 to 9 */
	FrmShowObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_BoldFont) );	/* draw in bold */	
	FrmHideObject (theFormP, FrmGetObjectIndex ( theFormP, kCheckBoxIdControl_BackWhite) );	/* hide backWhite */
}

static void GetCheckBoxValue(FormPtr theFormP, CEWpref_t *aPrefsPtr)
{
	UInt32		theDepth;

	aPrefsPtr->DisplayIfNameIsNumberControlvalue =
		CtlGetValue ( GetObjectPtr(theFormP, kCheckBoxIdControl_DisplayIfNameNumber));
	aPrefsPtr->DisplayAlertClockControlvalue =
		CtlGetValue ( GetObjectPtr(theFormP, kCheckBoxIdControl_DisplayAlert));
	aPrefsPtr->BlinkingSecondControlvalue =
		CtlGetValue ( GetObjectPtr(theFormP, kCheckBoxIdControl_Blink));
	aPrefsPtr->AnalogClockControlvalue =
		CtlGetValue ( GetObjectPtr(theFormP, kCheckBoxIdControl_Analog));
	aPrefsPtr->WhiteBackgroundControlvalue =
		CtlGetValue ( GetObjectPtr(theFormP, kCheckBoxIdControl_BackWhite));
	aPrefsPtr->DisplayAlertClockRightControlvalue =
		CtlGetValue ( GetObjectPtr(theFormP, kCheckBoxIdControl_DisplayAlertRight));
	aPrefsPtr->DisplayAnalogOn12Hour =
		(UInt8)LstGetSelection ( GetObjectPtr(theFormP, kListId_Format));
	aPrefsPtr->Add0Before1To9 =
		CtlGetValue ( GetObjectPtr(theFormP, kCheckBoxIdControl_Add0Before1To9));
	WinScreenMode (winScreenModeGet, NULL, NULL, &theDepth, NULL);
	if (theDepth > 4)
		aPrefsPtr->DisplayIsInColor = theDepth;
	else
		aPrefsPtr->DisplayIsInColor = 0;
	aPrefsPtr->FontInBold =
		CtlGetValue ( GetObjectPtr(theFormP, kCheckBoxIdControl_BoldFont));	
}


// in setup on each user action I redraw the clock
static void ForceClockRedraw(FormPtr theFormP)
{
	CEWpref_t	thePrefs;

	Utils_GetHackPref( &thePrefs);						// get the pref
	GetCheckBoxValue( theFormP, &thePrefs);			// update the pref
	FrmDrawForm( theFormP );								// draw the form
	Utils_DrawTheClock( theFormP, true, &thePrefs);	// draw the clock
}
